#!/bin/sh

PATH="/bin:/usr/bin"
LANG=ja_JP.eucJP


#----------------------------------------#
# Define the vital variables             #
#----------------------------------------#

RESULT="/var/addpoint/upgrade/result.txt"
UPGRADEDIR="/var/addpoint/upgrade/melted"


HISTORY="/var/addpoint/upgrade_history.dat"
if [ ! -e ${HISTORY} ]; then
	echo "/var/addpoint/upgrade_history.dat: File not found. Exit." > ${RESULT}
	echo "Ŭǡե뤬Ĥޤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


IDENTITY=`sed -n 's/^identity://p' addpoint-package.check`
if [ $? -ne 0 ]; then
	echo "sed -n 's/^identity://p' addpoint-package.check : Can't execute. Exit." > ${RESULT}
	echo "ѿIDENTITYǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi



#----------------------------------------#
# Check the upgrade history              #
#----------------------------------------#
#if the same patch has already been installed,
#install.sh won't be executed.
#PASTID=`cut -d, -f4 ${HISTORY} | grep ${IDENTITY} | uniq`
#if [ $? -ne 0 ]; then
#	echo "cut -d -f4 ${HISTORY} | grep ${IDENTITY} | uniq : Can't execute. Exit." > ${RESULT}
#	echo "ѿPASTIDǤޤǤ" >> ${RESULT}
#	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
#	exit 1
#fi
#
#
#if [ "${PASTID}" = "${IDENTITY}" ]; then
#	echo "񤭥åץǡȤǤʤѥåǤ" > ${RESULT} 
#	echo "ŬѤޤǤ" >> ${RESULT}
#	exit 1
#fi
#
#
#----------------------------------------#
# Define the other variables             #
#----------------------------------------#

TIME=`date +%Yǯ%m%d%k%Mʬ`
if [ $? -ne 0 ]; then
	echo "date +%Yǯ%m%d%k%Mʬ : Can't execute. Exit." > ${RESULT}
	echo "ѿTIMEǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


SUMMARY=`sed -n 's/^summary://p' addpoint-package.check`
if [ $? -ne 0 ]; then
	echo "sed -n 's/^summary://p' addpoint-package.check : Can't execute. Exit." > ${RESULT}
	echo "ѿSUMMARYǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


DATE_OF_ISSUE=`sed -n 's/^date_of_issue://p' addpoint-package.check`
if [ $? -ne 0 ]; then
	echo "sed -n 's/^date_of_issue://p' addpoint-package.check : Can't execute. Exit." > ${RESULT}
	echo "ѿDATE_OF_ISSUEǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


LAST_MESSAGE=`sed -n 's/^last_message://p' addpoint-package.check`
if [ $? -ne 0 ]; then
	echo "sed -n 's/^last_message://p' addpoint-package.check : Can't execute. Exit." > ${RESULT}
	echo "ѿLAST_MESSAGEǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


# patch name
P_NAME="${IDENTITY}"

DATESTR=`date '+%Y%m%d-%H%M%S'`
if [ $? -ne 0 ]; then
	echo "date '+%Y%m%d-%H%M%S' : Can't execute. Exit." > ${RESULT}
	echo "ѿDATESTRǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


LOGDIR="/var/appatch/${P_NAME}-${DATESTR}"

TMPDIR=`mktemp -d /tmp/${P_NAME}.XXXXXX`
if [ $? -ne 0 ]; then
	echo "mktemp -d /tmp/${P_NAME}.XXXXXX : Can't execute. Exit." > ${RESULT}
	echo "ѿTMPDIRǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


#----------------------------------------#
# Create sticky-bitted psudo (perl-sudo) #
#----------------------------------------#
PSUDO="${TMPDIR}/psudo"

sudo /bin/tar cf - --owner=root --group=root -C ${UPGRADEDIR} psudo | sudo /bin/tar xf - -C ${TMPDIR}
if [ ! -e ${PSUDO} ]; then
	echo "${PSUDO} : No such file. Exit." > ${RESULT}
	echo "ե${PSUDO}¸ߤޤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


sudo /bin/chmod 6755 ${PSUDO}
if [ $? -ne 0 ]; then
	echo "sudo /bin/chmod 6755 ${PSUDO} : Can't execute. Exit." > ${RESULT}
	echo "${PSUDO}ǥ쥯ȥΥѡߥåѹǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi

#-------------------------------------#
# Make a directory to store patch log #
#-------------------------------------#

if [ ! -d /var/appatch ]; then
        ${PSUDO} mkdir /var/appatch
	if [ $? -ne 0 ]; then
	echo "${PSUDO} mkdir /var/appatch : Can't execute. Exit." > ${RESULT}
	echo "ŬѥǼǥ쥯ȥǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
	fi
        sudo chmod 755 /var/appatch
	if [ $? -ne 0 ]; then
	echo "sudo chmod 755 /var/appatch : Can't execute. Exit." > ${RESULT}
	echo "ŬѥǼǥ쥯ȥΥѡߥåѹǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
	fi
fi

if [ ! -d ${LOGDIR} ]; then
        ${PSUDO} mkdir ${LOGDIR}
	if [ $? -ne 0 ]; then
	echo "${PSUDO} mkdir ${LOGDIR} : Can't execute. Exit." > ${RESULT}
	echo "ŬѥǼǥ쥯ȥǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
	fi
        sudo chmod 777 ${LOGDIR}
	if [ $? -ne 0 ]; then
	echo "sudo chmod 777 ${LOGDIR} : Can't execute. Exit." > ${RESULT}
	echo "ŬѥǼǥ쥯ȥΥѡߥåѹǤޤǤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
	fi
fi

set -x
exec >${LOGDIR}/instlog 2>&1


################---------------------------------------------------------------
# main process #
################

#=================#
# Upgrade process #
#=================#

#--------------------#
#  revise conf.inf   #
#--------------------#

$PSUDO /etc/init.d/addpoint stop
if [ $? -ne 0 ]; then
	echo "$PSUDO /etc/init.d/addpoint stop : Can't stop addpoint service. Exit." >> ${RESULT}
	echo "addpointӥߤ˼Ԥޤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


sudo /bin/cp -p /usr/sbin/addpoint.sh /usr/sbin/addpoint.sh.bak
if [ $? -ne 0 ]; then
	echo "sudo /bin/cp -p /usr/sbin/addpoint.sh /usr/sbin/addpoint.sh.bak : Can't copy addpoint.sh. Exit." >> ${RESULT}
	echo "¸addpoint.shΥԡ˼Ԥޤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


sudo /bin/cp -p ${UPGRADEDIR}/002/addpoint.sh /usr/sbin/addpoint.sh
if [ $? -ne 0 ]; then
	echo "sudo /bin/cp -p ${UPGRADEDIR}addpoint.sh /usr/sbin/addpoint.sh" >> ${RESULT}
	echo "addpoint.sh֤˼Ԥޤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi


$PSUDO /etc/init.d/addpoint start
if [ $? -ne 0 ]; then
	echo "$PSUDO /etc/init.d/addpoint start : Can't start addpoint service. Exit." >> ${RESULT}
	echo "addpointӥεư˼Ԥޤ" >> ${RESULT}
	echo "ŬѤ˼Ԥޤ" >> ${RESULT}
	exit 1
fi

#######################
# end of main process #
#######################--------------------------------------------------------

find ${LOGDIR} -type f -exec sudo chmod 444 {} \;
find ${LOGDIR} -type d -exec sudo chmod 555 {} \;
sudo chmod 555 ${LOGDIR}

${PSUDO} rm -rf ${TMPDIR}

echo "${TIME},${SUMMARY},${DATE_OF_ISSUE},${IDENTITY}" >> $HISTORY
echo "${LAST_MESSAGE}" > ${RESULT}

#sudo /sbin/shutdown -r now

exit 0
